%define up_name labltk

# "fix" underlinking:
%define _disable_ld_no_undefined 1

Summary:       Tcl/Tk interface for OCaml
Name:          ocaml-%{up_name}
Version:       8.06.5
Release:       %mkrel 5
Group:         Development/OCaml
License:       LGPLv2+ with exceptions
URL:           https://forge.ocamlcore.org/projects/labltk/
# This link chnages every time and ignore the version
# Do not use %%version in here as it will download an old version named with the new version
Source0:       https://forge.ocamlcore.org/frs/download.php/1764/labltk-8.06.5.tar.gz
Source1:       META
# This adds debugging (-g) everywhere.
Patch1:        labltk-8.06.0-enable-debugging.patch
Patch2:        labltk-8.06.4-enable-more-debugging.patch
BuildRequires: ocaml-compiler
BuildRequires: ocaml-compiler-libs
BuildRequires: pkgconfig(tcl)
BuildRequires: pkgconfig(tk)

%description
labltk or mlTk is a library for interfacing OCaml with the scripting
language Tcl/Tk (all versions since 8.0.3, but no betas).

%package devel
Summary:       Tcl/Tk interface for OCaml
Requires:      %{name}%{?_isa} = %{version}-%{release}

%description devel
labltk or mlTk is a library for interfacing OCaml with the scripting
language Tcl/Tk (all versions since 8.0.3, but no betas).

This package contains the development files.

%prep
%setup -q -n labltk-%{version}
%autopatch -p1

# Remove version control files which might get copied into documentation.
find -name .gitignore -delete

# Kill -warn-error.
find -type f | xargs sed -i -e 's/-warn-error/-w/g'

# Don't build ocamlbrowser.
mv browser browser.old
mkdir browser
echo -e 'all:\ninstall:\n' > browser/Makefile

%build
./configure

# Build does not work in parallel.
unset MAKEFLAGS

make all opt \
     SHAREDCCCOMPOPTS="%{optflags} -fPIC" \
     TK_LINK="%{__global_ldflags} -ltk8.6 -ltcl8.6"

%install
mkdir -p %buildroot%{_bindir}
mkdir -p %buildroot%{_libdir}/ocaml/labltk
mkdir -p %buildroot%{_libdir}/ocaml/stublibs
make install \
    BINDIR=%buildroot%{_bindir} \
    INSTALLDIR=%buildroot%{_libdir}/ocaml/labltk \
    STUBLIBDIR=%buildroot%{_libdir}/ocaml/stublibs
# The *.o files are not installed by the Makefile.  AIUI
# that prevents linking with native code programs.
install -m 0644 camltk/*.o $RPM_BUILD_ROOT%{_libdir}/ocaml/labltk

install -m 0644 %{SOURCE1} %buildroot%{_libdir}/ocaml/labltk/META

%files
%doc Changes README.mlTk
%dir %{_libdir}/ocaml/labltk
%{_libdir}/ocaml/labltk/*.cmi
%{_libdir}/ocaml/labltk/*.cma
%{_libdir}/ocaml/labltk/*.cmo
%{_libdir}/ocaml/stublibs/dlllabltk.so
%{_libdir}/ocaml/labltk/META

%files devel
%doc README.mlTk
%doc examples_camltk
%doc examples_labltk
%{_bindir}/labltk
%{_libdir}/ocaml/labltk/labltktop
%{_libdir}/ocaml/labltk/pp
%{_libdir}/ocaml/labltk/tkcompiler
%{_libdir}/ocaml/labltk/*.a
%{_libdir}/ocaml/labltk/*.cmxa
%{_libdir}/ocaml/labltk/*.cmx
%{_libdir}/ocaml/labltk/*.o
%{_libdir}/ocaml/labltk/*.mli


%changelog
* Fri Aug 21 2020 umeabot <umeabot> 8.06.5-5.mga8
+ Revision: 1617569
- Rebuild for new ocaml deps generator

* Fri Feb 28 2020 umeabot <umeabot> 8.06.5-4.mga8
+ Revision: 1551145
- Rebuild for ocaml 4.10.0 final

* Wed Feb 19 2020 umeabot <umeabot> 8.06.5-3.mga8
+ Revision: 1544531
- Mageia 8 Mass Rebuild

* Sun Jan 26 2020 tv <tv> 8.06.5-2.mga8
+ Revision: 1483158
- rebuild for ocaml-4.10
- Don't build ocamlbrowser
- disable underlinking

* Tue Oct 23 2018 tv <tv> 8.06.5-2.mga7
+ Revision: 1324070
- rebuild with ocaml-4.07.1

* Mon Oct 22 2018 pterjan <pterjan> 8.06.5-1.mga7
+ Revision: 1323859
- Update to 8.06.5 to support new ocaml
- Rebuild for ocaml 4.07

* Sun Sep 23 2018 umeabot <umeabot> 8.06.4-2.mga7
+ Revision: 1299886
- Mageia 7 Mass Rebuild

* Sun Nov 26 2017 tv <tv> 8.06.4-1.mga7
+ Revision: 1179293
- new release
- use %%version in source URL
- parallel build is broken
- rebuild for new ocaml
- rebuild for new ocaml

* Thu Nov 24 2016 neoclust <neoclust> 8.06.0-3.mga6
+ Revision: 1069810
- Rebuild against fixed ocaml

* Mon Sep 26 2016 pterjan <pterjan> 8.06.0-2.mga6
+ Revision: 1056411
- Rebuild for fix in ocaml

* Fri Jan 29 2016 pterjan <pterjan> 8.06.0-1.mga6
+ Revision: 928672
- Add missing BuildRequires
- Ship META file from findlib
- imported package ocaml-labltk

